import { jsxs as R, jsx as n } from "react/jsx-runtime";
import { i as _, j as A } from "../../chunks/index.QZZEWZ4h.js";
import P, { useRef as S, useState as $, useLayoutEffect as j } from "react";
import { TEXT_INPUT_WRAPPER_CLASSNAME as X, r as F, TEXT_INPUT_CLASSNAME as T, TEXT_INPUT_HELPER_TEXT_CLASSNAME as U } from "../../chunks/constants.D-rfPeOH.js";
import a from "clsx";
const H = ({
  mode: t
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), W = ({
  focusMode: t,
  error: s
}) => s ? "focus:outline focus:outline-2 focus:outline-focus-error-dark" : a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), D = ({
  noBorder: t,
  error: s
}) => a("border-2", {
  "border-border-dark": !t,
  "border-transparent": t,
  "border-border-error-dark": s
}), M = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => s ? "" : a("absolute cursor-text font-medium", {
  "text-copy-lighter": !e && r === "dark",
  "text-copy-dark": !e && r === "light",
  "text-copy-dark dark:text-copy-lighter": !e && r === "system",
  "text-copy-lighter dark:text-copy-dark": !e && r === "alt-system",
  "cursor-not-allowed opacity-50": t
}), q = ({
  error: t,
  raw: s,
  mode: e
}) => s ? void 0 : a(U, "absolute px-2 font-medium", {
  "rounded-md bg-surface-darker text-copy-error-light": t,
  "text-copy-lighter": !t && e === "dark",
  "text-copy-dark": !t && e === "light",
  "text-copy-dark dark:text-copy-lighter": !t && e === "system",
  "text-copy-lighter dark:text-copy-dark": !t && e === "alt-system"
}), z = ({
  className: t,
  inputClassName: s,
  raw: e,
  disabled: r,
  noBorder: l,
  error: c,
  spacing: g,
  mode: u,
  focusMode: y
}) => {
  const p = e ? t : a(
    "relative flex w-full flex-col justify-center",
    X,
    t,
    F(g)
  ), h = e ? a(s) : a(
    T,
    s,
    "h-12 rounded-md px-4 text-base",
    H({ mode: u }),
    W({ focusMode: y, error: c }),
    D({ noBorder: l, error: c }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    }
  ), x = e ? void 0 : "sr-only", k = M({
    disabled: r,
    raw: e,
    error: c,
    mode: u
  }), b = q({
    error: c,
    raw: e,
    mode: u
  });
  return {
    wrapper: p,
    input: h,
    accessibleLabel: x,
    visibleLabel: k,
    helperText: b,
    rightElement: e ? void 0 : "absolute right-3"
  };
}, B = P.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: l = !1,
    className: c,
    inputClassName: g,
    mode: u = "system",
    focusMode: y = "system",
    disabled: p = !1,
    noBorder: h = !1,
    labelId: x,
    labelHidden: k = !1,
    type: b = "text",
    helperText: o = "",
    rightElement: f,
    spacing: I,
    ...E
  }, v) => {
    const m = S(null), [N, C] = $(0), d = _({ id: t, prefix: `${T}-` }), L = `${s} error, ${o}`, i = z({
      className: c,
      inputClassName: g,
      error: r,
      raw: l,
      focusMode: y,
      disabled: p,
      noBorder: h,
      spacing: I,
      mode: u
    });
    return j(() => {
      m.current && C(m.current.offsetWidth + 18 + 10);
    }, [f]), /* @__PURE__ */ R("div", { className: i.wrapper, children: [
      /* @__PURE__ */ n(
        "label",
        {
          htmlFor: d,
          id: x,
          className: i.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ n(
        "input",
        {
          ref: v,
          id: d,
          name: s,
          type: b,
          disabled: p,
          placeholder: l ? void 0 : " ",
          className: i.input,
          ...o && { "aria-describedby": `${d}-helper` },
          ...r && { "aria-invalid": "true" },
          ...f && !l && { style: { paddingRight: N } },
          ...E
        }
      ),
      !l && !k && /* @__PURE__ */ n(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: d,
          className: i.visibleLabel,
          children: e
        }
      ),
      o && /* @__PURE__ */ n(
        "div",
        {
          id: `${d}-helper`,
          className: i.helperText,
          children: o
        }
      ),
      f && /* @__PURE__ */ n(
        "div",
        {
          ref: m,
          className: i.rightElement,
          children: f
        }
      ),
      r && o && /* @__PURE__ */ n(A, { politeness: "polite", clearAnnouncementDelay: 500, children: L })
    ] });
  }
);
B.displayName = "TextInput";
export {
  B as TextInput
};
