import { jsxs as ee, jsx as A } from "react/jsx-runtime";
import { o as te } from "../../chunks/useMergeRefs.DYDIMIZh.js";
import re, { useState as F, useRef as p, useLayoutEffect as E } from "react";
import { i as se, j as ae } from "../../chunks/index.QZZEWZ4h.js";
import { TEXT_AREA_WRAPPER_CLASSNAME as le, r as oe, TEXT_AREA_CLASSNAME as W, TEXT_AREA_CONTROL_RIGHT_CLASSNAME as ce, TEXT_AREA_HELPER_TEXT_CLASSNAME as ne } from "../../chunks/constants.D-rfPeOH.js";
import f from "clsx";
function ie({
  value: e,
  defaultValue: r,
  finalValue: t,
  onChange: a = () => {
  }
}) {
  const [s, x] = F(
    r !== void 0 ? r : t
  );
  return e !== void 0 ? [e, a, !0] : [s, (c) => {
    x(c), a == null || a(c);
  }, !1];
}
const ue = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", fe = ({
  mode: e
}) => f({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), de = ({
  focusMode: e,
  error: r
}) => r ? "focus:outline focus:outline-2 focus:outline-focus-error-dark" : f("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), pe = ({
  noBorder: e,
  error: r
}) => f("border-2", {
  "border-border-dark": !e,
  "border-transparent": e,
  "border-border-error-dark": r
}), xe = ({
  disabled: e,
  raw: r,
  error: t,
  mode: a
}) => r ? "" : f("absolute cursor-text font-medium", {
  "text-copy-lighter": !t && a === "dark",
  "text-copy-dark": !t && a === "light",
  "text-copy-dark dark:text-copy-lighter": !t && a === "system",
  "text-copy-lighter dark:text-copy-dark": !t && a === "alt-system",
  "cursor-not-allowed opacity-50": e
}), he = ({
  error: e,
  raw: r,
  mode: t
}) => r ? void 0 : f(ne, "absolute px-2 font-medium", {
  "rounded-md bg-surface-darker text-copy-error-light": e,
  "text-copy-lighter": !e && t === "dark",
  "text-copy-dark": !e && t === "light",
  "text-copy-dark dark:text-copy-lighter": !e && t === "system",
  "text-copy-lighter dark:text-copy-dark": !e && t === "alt-system"
}), ge = ({
  className: e,
  textAreaClassName: r,
  raw: t,
  focusMode: a,
  disabled: s,
  noBorder: x,
  error: o,
  spacing: c,
  mode: n
}) => {
  const h = t ? e : f(
    "relative flex w-full flex-col justify-center",
    le,
    e,
    oe(c)
  ), v = t ? f(r) : f(
    W,
    r,
    ue(),
    fe({ mode: n }),
    de({ focusMode: a, error: o }),
    pe({
      noBorder: x,
      error: o
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": s
    }
  ), T = t ? void 0 : "sr-only", R = xe({
    disabled: s,
    raw: t,
    error: o,
    mode: n
  }), _ = he({
    error: o,
    raw: t,
    mode: n
  }), i = t ? void 0 : f(ce, "absolute");
  return {
    wrapper: h,
    textArea: v,
    accessibleLabel: T,
    visibleLabel: R,
    helperText: _,
    rightElement: i
  };
}, ye = ({
  scrollHeight: e,
  currentHeight: r,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: a = 0
}) => {
  let o, c;
  if (e > 0 && e !== r) {
    const n = e - r, h = Math.abs(n / 24);
    o = t + -1 * Math.sign(n) * (12 * h), c = a + Math.sign(n) * (12 * h);
  }
  return {
    labelOffset: o,
    helperTextOffset: c,
    scrollHeight: e
  };
}, Ae = re.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: a = !1,
    raw: s = !1,
    className: x,
    textAreaClassName: o,
    mode: c = "system",
    focusMode: n = "system",
    value: h,
    defaultValue: v,
    disabled: T = !1,
    noBorder: R = !1,
    labelId: _,
    helperText: i = "",
    helperTextOnFocus: L = !1,
    rightElement: b,
    onChange: I,
    onFocus: P,
    onBlur: $,
    spacing: B,
    ...G
  }, V) => {
    const u = p(null), z = te([V, u]), N = p(null), C = p(80), j = p(-25), d = p(null), M = p(30), m = p(null), k = se({ id: e, prefix: `${W}-` }), [D, q] = F(0), [J, X] = F(
      !!(!L && i)
    ), K = `${r} error, ${i}`, g = ge({
      className: x,
      textAreaClassName: o,
      error: a,
      raw: s,
      focusMode: n,
      disabled: T,
      noBorder: R,
      spacing: B,
      mode: c
    }), [y, Q] = ie({
      value: h,
      defaultValue: v,
      onChange: (l) => {
        I && I({
          target: {
            value: l
          }
        });
      }
    }), U = (l) => {
      Q(l.target.value);
    }, Y = (l) => {
      L && i && X(!0), P && P(l);
    }, Z = (l) => {
      L && i && !y && X(!1), $ && $(l);
    };
    return E(() => {
      !s && N.current && q(N.current.offsetWidth + 18 + 10);
    }, [b, s]), E(() => {
      s || u && u.current && (u.current.style.height = "inherit", u.current.style.height = u.current.scrollHeight + "px");
    }, [y, s]), E(() => {
      s || setTimeout(() => {
        var l;
        (l = d == null ? void 0 : d.current) == null || l.style.setProperty(
          "--av-text-area-wrapper-transition",
          y ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [y, s]), E(() => {
      var l, O;
      if (!s && u && u.current) {
        const { labelOffset: S, helperTextOffset: H, scrollHeight: w } = ye({
          scrollHeight: u.current.scrollHeight,
          currentHeight: C.current,
          currentLabelOffset: j.current,
          currentHelperTextOffset: M.current
        });
        S && (j.current = S, (l = d == null ? void 0 : d.current) == null || l.style.setProperty(
          "--av-text-area-label",
          `${S}px`
        )), H && (M.current = H, (O = m == null ? void 0 : m.current) == null || O.style.setProperty(
          "--av-text-area-helper-text",
          `${H}px`
        )), C.current = w || C.current;
      }
    }, [y, s]), /* @__PURE__ */ ee("div", { className: g.wrapper, children: [
      /* @__PURE__ */ A(
        "label",
        {
          htmlFor: k,
          id: _,
          className: g.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ A(
        "textarea",
        {
          ref: z,
          id: k,
          name: r,
          disabled: T,
          placeholder: s ? void 0 : " ",
          className: g.textArea,
          rows: 1,
          ...i && { "aria-describedby": `${k}-helper` },
          ...a && { "aria-invalid": "true" },
          ...b && !s && { style: { paddingRight: D } },
          value: y,
          onChange: U,
          onFocus: Y,
          onBlur: Z,
          ...G
        }
      ),
      !s && /* @__PURE__ */ A(
        "label",
        {
          ref: d,
          "aria-hidden": !0,
          htmlFor: k,
          className: g.visibleLabel,
          children: t
        }
      ),
      J && /* @__PURE__ */ A(
        "div",
        {
          ref: m,
          id: `${k}-helper`,
          className: g.helperText,
          children: i
        }
      ),
      b && /* @__PURE__ */ A(
        "div",
        {
          ref: N,
          className: g.rightElement,
          children: b
        }
      ),
      a && i && /* @__PURE__ */ A(ae, { politeness: "polite", clearAnnouncementDelay: 500, children: K })
    ] });
  }
);
Ae.displayName = "TextArea";
export {
  Ae as TextArea
};
